-- This script will fix sync issues when trying to sync Contacts between a Mac and an iOS device
-- It replaces any instances of "son" or "saughter" with "child" in the Mac "Contacts" app
-- WARNING: be sure to back up your contacts (File-Export-Contacts archive) in the Contacts app before proceeding, in case you need to revert
-- script source: https://forums.macrumors.com/threads/contacts-how-to-locate-fix-corrupt-entries.2342937

use AppleScript version "2.4" -- Yosemite (10.10) or later
use scripting additions

display dialog "Replace all SON or DAUGHTER fields with CHILD?" with title "Contacts sync repair" buttons {"Cancel", "OK"} default button 1 with icon caution

if the button returned of the result is "OK" then
	set numberOfCards to 0
	set numberOfFields to 0
	tell application "Contacts"
		set startList to label of (every related name of people whose label is "son" or label is "daughter")
		repeat with pers in people
			set relatedNames to (every related name of pers whose label is "son" or label is "daughter")
			if relatedNames is not {} then
				set numberOfFields to numberOfFields + (count of relatedNames)
				set numberOfCards to numberOfCards + 1
				set label of (every related name of pers whose label is "son" or label is "daughter") to "child"
				save
			end if
		end repeat
		set endList to label of (every related name of people whose label is "son" or label is "daughter")
	end tell
end if

if startList is equal to endList then
	display dialog "Nothing to repair!" with title "Title" buttons {"OK"} default button 1 with icon stop --giving up after 5
else
	display dialog ((numberOfCards as text) & space & "cards updated." & return & numberOfFields as text) & space & "fields changed." with title "Repair done!" buttons {"OK"} default button 1 with icon note --giving up after 5
end if
